# class XMLRPC::ModRubyServer

Implements a XML-RPC server, which works with Apache mod_ruby.

Use it in the same way as XMLRPC::CGIServer!

### Public Class Methods

new(*a) click to toggle source

Creates a new XMLRPC::ModRubyServer instance.

All parameters given are by-passed to XMLRPC::BasicServer.new.

Calls superclass method XMLRPC::BasicServer.new

    # File lib/xmlrpc/server.rb, line 467
    def initialize(*a)
      @ap = Apache::request
      super(*a)
    end

### Public Instance Methods

serve() click to toggle source

Call this after you have added all you handlers to the server.

This method processes a XML-RPC method call and sends the answer back to the client.

    # File lib/xmlrpc/server.rb, line 476
    def serve
      catch(:exit_serve) {
        header = {}
        @ap.headers_in.each {|key, value| header[key.capitalize] = value}

        length = header['Content-length'].to_i

        http_error(405, "Method Not Allowed") unless @ap.request_method  == "POST"
        http_error(400, "Bad Request")        unless parse_content_type(header['Content-type']).first == "text/xml"
        http_error(411, "Length Required")    unless length > 0

        # TODO: do we need a call to binmode?
        @ap.binmode
        data = @ap.read(length)

        http_error(400, "Bad Request")        if data.nil? or data.bytesize != length

        http_write(process(data), 200, "Content-type" => "text/xml; charset=utf-8")
      }
    end

### Private Instance Methods

http_error(status, message) click to toggle source

    # File lib/xmlrpc/server.rb, line 500
    def http_error(status, message)
      err = "#{status} #{message}"
      msg = <<-"MSGEND"
        <html>
          <head>
            <title>#{err}</title>
          </head>
          <body>
            <h1>#{err}</h1>
            <p>Unexpected error occurred while processing XML-RPC request!</p>
          </body>
        </html>
      MSGEND

      http_write(msg, status, "Status" => err, "Content-type" => "text/html")
      throw :exit_serve # exit from the #serve method
    end

http_write(body, status, header) click to toggle source

    # File lib/xmlrpc/server.rb, line 518
    def http_write(body, status, header)
      h = {}
      header.each {|key, value| h[key.to_s.capitalize] = value}
      h['Status']         ||= "200 OK"
      h['Content-length'] ||= body.bytesize.to_s

      h.each {|key, value| @ap.headers_out[key] = value }
      @ap.content_type = h["Content-type"]
      @ap.status = status.to_i
      @ap.send_http_header

      @ap.print body
    end